#include "StdAfx.h"
#include ".\idvrmimpcompositingmodelsw.h"
#using <mscorlib.dll>

using namespace IDVR::VolumeRenderer::SWVolumeRenderer::IDVRCompositingModels;

//This is the standard constructor.
//This standard constructor initialzed all elements with zero, exept the gradientScaleFactor with 1.

IDVRMImPCompositingModelSW::IDVRMImPCompositingModelSW(void)
{
	this->m_IIDVRModulatior =NULL;
	this->m_LevelsOfSparseness = NULL;
	this->m_CountersinkSlope = NULL;
	this->m_GradientScaleFactor = 1;
}

//Constuctor.
IDVRMImPCompositingModelSW::IDVRMImPCompositingModelSW(IIDVRModulationModel *n_IIDVRModulator)
{
	this->m_IIDVRModulatior = n_IIDVRModulator;
	this->m_FootprintArrayList = new ArrayList();
	this->m_LevelsOfSparseness = new Hashtable();
	this->m_CountersinkSlope = 1.0;
	this->m_GradientScaleFactor = 1;
}

//Constuctor.
IDVRMImPCompositingModelSW::IDVRMImPCompositingModelSW(IIDVRModulationModel *n_IIDVRModulator, double n_CountersinkSlope, double n_GradientScaleFactor)
{
	this->m_IIDVRModulatior = n_IIDVRModulator;
	this->m_FootprintArrayList = new ArrayList();
	this->m_LevelsOfSparseness = new Hashtable();
	this->m_CountersinkSlope = n_CountersinkSlope;
	this->m_GradientScaleFactor = n_GradientScaleFactor;
}

//Standard destructor.
IDVRMImPCompositingModelSW::~IDVRMImPCompositingModelSW(void)
{
	this->m_FootprintArrayList = NULL;
	this->m_LevelsOfSparseness = NULL;
}

//Assigns the level of sparseness hashtable.
void IDVRMImPCompositingModelSW::doCompositing(void)
{
	this->m_LevelsOfSparseness = new Hashtable();

	short objectIDWithMaxImp = Int16::MinValue;
	short maxImportance = Int16::MinValue;

	/*for(int i = 0; i < this->m_FootprintArrayList->get_Count(); i++)
	{
		FootprintElement *currFootprintElement = __try_cast<FootprintElement*>(this->m_FootprintArrayList->get_Item(i));

		if(currFootprintElement->getImportance() > maxImportance)
		{
			//add objectID to hashtabe with max sparseness value 1.0;
			this->m_LevelsOfSparseness->set_Item(__box(objectIDWithMaxImp), __box(0.0f));
			this->m_LevelsOfSparseness->Add(__box(currFootprintElement->getObjectID()), __box(1.0f));
			objectIDWithMaxImp = currFootprintElement->getObjectID();
			maxImportance = currFootprintElement->getImportance();
		}
		else
		{
			//add objectID to hashtabe with min sparseness value 0.0;
			this->m_LevelsOfSparseness->Add(__box(currFootprintElement->getObjectID()), __box(0.0f));
		}	
	}*/
	if(this->m_FootprintArrayList != NULL && this->m_FootprintArrayList->get_Count() != 0)
	{
		for(int i = 0; i < this->m_FootprintArrayList->get_Count(); i++)
		{
			FootprintElement *currFootprintElement = __try_cast<FootprintElement*>(this->m_FootprintArrayList->get_Item(i));

			//get objectID with maximal importance
			if(currFootprintElement->getImportance() > maxImportance)
			{
				objectIDWithMaxImp = currFootprintElement->getObjectID();
				maxImportance = currFootprintElement->getImportance();
			}
		}

		for(int i = 0; i < this->m_FootprintArrayList->get_Count(); i++)
		{
			FootprintElement *currFootprintElement = __try_cast<FootprintElement*>(this->m_FootprintArrayList->get_Item(i));

			if(currFootprintElement->getObjectID() == objectIDWithMaxImp)
			{
				//add objectID to hashtabe with max sparseness value 1.0;
				this->m_LevelsOfSparseness->Add(__box(currFootprintElement->getObjectID()), __box(1.0f));
			}
			else
			{
				//add objectID to hashtabe with min sparseness value 0.0;
				this->m_LevelsOfSparseness->Add(__box(currFootprintElement->getObjectID()), __box(0.0f));
			}	
		}
	}
}

//Calls the modifyRaySample method of the IDVRModulation interface.
RaySample* IDVRMImPCompositingModelSW::modifyRaySample(RaySample *n_RaySample)
{
	return this->m_IIDVRModulatior->doModulation(n_RaySample, this->m_LevelsOfSparseness);
}

//Sets the objectID list.
void IDVRMImPCompositingModelSW::setFootprintArrayList(ArrayList *n_FootprintArrayList)
{
	this->m_FootprintArrayList = n_FootprintArrayList;
}

//Returns the IDVRModulation interface.
IIDVRModulationModel* IDVRMImPCompositingModelSW::getIIDVRModulationModel(void)
{
	return this->m_IIDVRModulatior;
}

//Sets the IDVRModulation interface.
void IDVRMImPCompositingModelSW::setIIDVRModulatonModel(IIDVRModulationModel *n_IIDVRModulationModel)
{
	this->m_IIDVRModulatior = n_IIDVRModulationModel;
}

//Sets the countersink slope.
void IDVRMImPCompositingModelSW::setCountersinkSlope(double n_CountersinkSlope)
{
	this->m_CountersinkSlope = n_CountersinkSlope;
}

//Sets the gradient scalefactor.
void IDVRMImPCompositingModelSW::setGradientScaleFactor(double n_GradientScaleFactor)
{
	this->m_GradientScaleFactor = n_GradientScaleFactor;
}

//Returns the countersink slope.
double IDVRMImPCompositingModelSW::getCountersinkSlope(void)
{
	return this->m_CountersinkSlope;
}

//Returns the gradient scalefactor.
double IDVRMImPCompositingModelSW::getGradientScaleFactor(void)
{
	return this->m_GradientScaleFactor;
}