#include "StdAfx.h"
#include ".\raysample.h"
#using <mscorlib.dll>

using namespace IDVR::VolumeRenderer::RenderPrimitives;

//This is the standard constructor.
//This standard constructor initialzed all elements with zero.
RaySample::RaySample(void)
{
	this->m_Coords = NULL;
	this->m_Opacity = 0;
	this->m_Color = 0;
	this->m_Density = 0;
	this->m_ObjectID = 0;
	this->m_Gradient = NULL;
}

//This constructor initalized a raysample with the given coordinates. All other parmeters are set to zero.
RaySample::RaySample(Vector3* n_Coords)
{
	this->m_Coords = n_Coords;
	this->m_Opacity = 0;
	this->m_Color = 0;
	this->m_Density = 0;
	this->m_ObjectID = 0;
	this->m_Gradient = NULL;
}

//This constructor initalized a raysample with the given parameters.
RaySample::RaySample(float n_Color __gc[], float n_Opacity, unsigned short n_ObjectID)
{
	this->m_Color = n_Color; 
	this->m_Opacity = n_Opacity;
	this->m_Coords = NULL;
	this->m_Density = 0;
	this->m_ObjectID = n_ObjectID;
	this->m_Gradient = NULL;
}

//This is the standard destructor.
RaySample::~RaySample(void)
{
	this->m_Gradient = NULL;
	this->m_Coords = NULL;
	this->m_Color = NULL;
}

//Sets the color of the raysample.
void RaySample::set_Color(float n_Color __gc[])
{
	this->m_Color = n_Color;
}

//Sets the density of the raysample.
void RaySample::set_Density(unsigned short n_Density)
{
	this->m_Density = n_Density;
}

//Sets the opacity of the raysample.
void RaySample::set_Opacity(float n_Opacity)
{
	this->m_Opacity = n_Opacity;
}

//Sets the gradient of the raysample.
void RaySample::set_Gradient(RenderPrimitives::Gradient* n_Gradient)
{
	this->m_Gradient = n_Gradient;
}

//Sets the objectID of the raysample.
void RaySample::set_ObjectID(unsigned short n_ObjectID)
{
	this->m_ObjectID = n_ObjectID;
}

//Sets the coordinates of the raysample.
void RaySample::set_Coords(Vector3 *n_Coords)
{
	this->m_Coords = n_Coords;
}

//Returns the color of the raysample.
float RaySample::get_Color(void) __gc[]
{
	return this->m_Color;
}

//Returns the density of the raysample.
unsigned short RaySample::get_Density(void)
{
	return this->m_Density;
}

//Returns the opacity of the raysample.
float RaySample::get_Opacity(void)
{
	return this->m_Opacity;
}

//Returns the gradient of the raysample.
Gradient* RaySample::get_Gradient(void)
{
	return this->m_Gradient;
}

//Returns the objectID of the raysample.
unsigned short RaySample::get_ObjectID(void)
{
	return this->m_ObjectID;
}

//Returns the coordinates of the raysample.
Vector3* RaySample::get_Coords(void)
{
	return this->m_Coords;
}