#include "StdAfx.h"
#include "SliceViewer.h"

#using <mscorlib.dll>

using namespace IDVR;

//Sets the subitem for the GUI.
void SliceViewer::setControlSubItem(TD::SandBar::MenuButtonItem *n_SubItem_SliceViewer)
{
	this->m_SubItem_SliceViewer = n_SubItem_SliceViewer;
}

//Sets the toolbar subitem for the GUI.
void SliceViewer::setControlTbSubItem(TD::SandBar::MenuButtonItem *n_TbSubItem_SliceViewer)
{
	this->m_TbSubItem_SliceViewer = n_TbSubItem_SliceViewer;
}

//Resizes the canvas.
void SliceViewer::resizeCanvas(void)
{
	unsigned short dim __gc[] = this->m_VolumeData->get_VolumeDimension();
	Point newPoint;
			
	switch(this->cob_SliceXYZ->SelectedIndex)
	{
	case X:
		newPoint = Point((this->pan_Slices->Width - Convert::ToInt32(dim[Z] * this->m_SamplingFactor)) / 2,
							   (this->pan_Slices->Height - Convert::ToInt32(dim[Y] * this->m_SamplingFactor)) / 2);
		this->openGLPanel->set_Location(newPoint);
		this->openGLPanel->set_Size(System::Drawing::Size(Convert::ToInt32(dim[Z] * this->m_SamplingFactor), Convert::ToInt32(dim[Y] * this->m_SamplingFactor)));

		this->trb_Slices->set_Maximum(Convert::ToInt32(dim[X]));
		this->trb_Slices->set_Value(this->trb_Slices->get_Minimum());
		break;

	case Y:
		newPoint = Point((this->pan_Slices->Width - Convert::ToInt32(dim[X] * this->m_SamplingFactor)) / 2,
							   (this->pan_Slices->Height - Convert::ToInt32(dim[Z] * this->m_SamplingFactor)) / 2);
		this->openGLPanel->set_Location(newPoint);
		this->openGLPanel->set_Size(System::Drawing::Size(Convert::ToInt32(dim[X] * this->m_SamplingFactor), Convert::ToInt32(dim[Z] * this->m_SamplingFactor)));

		this->trb_Slices->set_Maximum(Convert::ToInt32(dim[Y]));
		this->trb_Slices->set_Value(this->trb_Slices->get_Minimum());
		break;

	case Z:
		newPoint = Point((this->pan_Slices->Width - Convert::ToInt32(dim[X] * this->m_SamplingFactor)) / 2,
							   (this->pan_Slices->Height - Convert::ToInt32(dim[Y] * this->m_SamplingFactor)) / 2);
		this->openGLPanel->set_Location(newPoint);
		this->openGLPanel->set_Size(System::Drawing::Size(Convert::ToInt32(dim[X] * this->m_SamplingFactor), Convert::ToInt32(dim[Y] * this->m_SamplingFactor)));

		this->trb_Slices->set_Maximum(Convert::ToInt32(dim[Z]));
		this->trb_Slices->set_Value(this->trb_Slices->get_Minimum());
		break;

	default:	break;
	}

	this->tex_SliceNumber->set_Text(Convert::ToString(this->trb_Slices->get_Value()));
}

//Draws the actual slice.
void SliceViewer::drawSlice(void)
{
this->pan_Slices->Width, this->pan_Slices->Height, 	this->tex_SliceNumber->set_Text(Convert::ToString(this->trb_Slices->get_Value()));

	unsigned short slice __gc[,] = NULL;
	unsigned short dim __gc[] = this->m_VolumeData->get_VolumeDimension();
	unsigned char frameBuffer __gc[] = NULL;
	RaySample *samplePoint = NULL;
	int bufferIndex = 0;

	this->m_Classificator = new LinearClassificationModelSW(DataLoader::DensityScope);
	this->m_Shader = new MipShadingModelSW(DataLoader::DensityScope, this->colDia_SliceColor->get_Color());

	try
	{
		switch(this->cob_SliceXYZ->SelectedIndex)
		{
		case X:
				slice = this->m_VolumeData->getVoxelSliceX(this->trb_Slices->get_Value());
				frameBuffer = new unsigned char __gc[dim[Z] * dim[Y] * 3];

				for(unsigned short j = 0; j < dim[Y]; j++)
				{
					for(unsigned short i = 0; i < dim[Z]; i++)
					{
						samplePoint = new RaySample();
						samplePoint->set_Density(slice[i, j]);
						samplePoint = this->m_Classificator->doClassification(samplePoint);
						samplePoint = this->m_Shader->doShading(samplePoint);

						frameBuffer[bufferIndex++] = 
									Convert::ToByte(Math::Round(samplePoint->get_Color()[X] * 255.0f));
						frameBuffer[bufferIndex++] = 
						        	Convert::ToByte(Math::Round(samplePoint->get_Color()[Y] * 255.0f));
						frameBuffer[bufferIndex++] = 
									Convert::ToByte(Math::Round(samplePoint->get_Color()[Z] * 255.0f));
					}
				}
				this->m_DrawModel = new DrawModelGLSW(this->openGLPanel->Width, this->openGLPanel->Height, dim[Z], dim[Y], frameBuffer, Color::Black);
				break;

		case Y:
				slice = this->m_VolumeData->getVoxelSliceY(this->trb_Slices->get_Value());
				frameBuffer = new unsigned char __gc[dim[X] * dim[Z] * 3];

				for(unsigned short j = 0; j < dim[Z]; j++)
				{
					for(unsigned short i = 0; i < dim[X]; i++)
					{
						samplePoint = new RaySample();
						samplePoint->set_Density(slice[i, j]);
						samplePoint = this->m_Classificator->doClassification(samplePoint);
						samplePoint = this->m_Shader->doShading(samplePoint);

						frameBuffer[bufferIndex++] = 
									Convert::ToByte(Math::Round(samplePoint->get_Color()[X] * 255.0f));
						frameBuffer[bufferIndex++] = 
						        	Convert::ToByte(Math::Round(samplePoint->get_Color()[Y] * 255.0f));
						frameBuffer[bufferIndex++] = 
									Convert::ToByte(Math::Round(samplePoint->get_Color()[Z] * 255.0f));
					}
				}

				this->m_DrawModel = new DrawModelGLSW(this->openGLPanel->Width, this->openGLPanel->Height, dim[X], dim[Z], frameBuffer, Color::Black);
				break;

		case Z:
				slice = this->m_VolumeData->getVoxelSliceZ(this->trb_Slices->get_Value());
				frameBuffer = new unsigned char __gc[dim[X] * dim[Y] * 3];

				for(unsigned short j = 0; j < dim[Y]; j++)
				{
					for(unsigned short i = 0; i < dim[X]; i++)
					{
						samplePoint = new RaySample();
						samplePoint->set_Density(slice[i, j]);
						samplePoint = this->m_Classificator->doClassification(samplePoint);
						samplePoint = this->m_Shader->doShading(samplePoint);
								
						frameBuffer[bufferIndex++] = 
									Convert::ToByte(Math::Round(samplePoint->get_Color()[X] * 255.0f));
						frameBuffer[bufferIndex++] = 
						        	Convert::ToByte(Math::Round(samplePoint->get_Color()[Y] * 255.0f));
						frameBuffer[bufferIndex++] = 
									Convert::ToByte(Math::Round(samplePoint->get_Color()[Z] * 255.0f));
					}
				}

				this->m_DrawModel = new DrawModelGLSW(this->openGLPanel->Width, this->openGLPanel->Height, dim[X], dim[Y], frameBuffer, Color::Black);
				break;

		default: break;
		}
	}catch(Exception*){	}

	this->openGLPanel->set_Code(this->m_DrawModel);
	this->openGLPanel->Refresh();
}