#include "StdAfx.h"
#include ".\TFClassificationModelSW.h"
#using <mscorlib.dll>

using namespace IDVR::VolumeRenderer::SWVolumeRenderer::ClassificationModels;

//Constructor.
TFClassificationModelSW::TFClassificationModelSW(Transferfunction *n_TransferFunc)
{
	this->m_TransferFunc = n_TransferFunc; 
}

//Calculates the opacity vale for a given raysample according to the specified transfer function.
RaySample* TFClassificationModelSW::doClassification(RaySample* n_RaySample)
{
	//calculates the opacity value according to the transfer function
	n_RaySample->set_Opacity(this->m_TransferFunc->getOpacity(n_RaySample->get_Density()));
	return n_RaySample;
}

//Sets the transfer function.
void TFClassificationModelSW::set_TransferFunc(Transferfunction* n_TransferFunc) 
{ 
	this->m_TransferFunc = n_TransferFunc; 
}

//Returns the transfer function.
Transferfunction* TFClassificationModelSW::get_TransferFunc(void)
{
	return this->m_TransferFunc; 
}