#include "StdAfx.h"
#include "TransferFuncWin.h"

#using <mscorlib.dll>

using namespace IDVR;

//Sorts all color indices.
void TransferFuncWin::sort_ColorIndices(void)
{
	if (this->colorSamples->get_Count() != 0)
	sortedIndicesColor = new int __gc[this->colorSamples->get_Count()];
	else 
	{
	sortedIndicesColor = NULL;
	return;
	}

	IDictionaryEnumerator* nextPos = this->colorSamples->GetEnumerator();
	int index = 0;

	while (nextPos->MoveNext())
		sortedIndicesColor[index++] = Convert::ToInt32(nextPos->get_Key());		 
	Array::Sort(sortedIndicesColor);
}

//Sorts all opacity indices.
void TransferFuncWin::sort_OpacityIndices(void)
{
	sortedIndicesOpacity = new int __gc[this->opacitySamples->get_Count()];

	IDictionaryEnumerator* nextPos = this->opacitySamples->GetEnumerator();
	int index = 0;

	while (nextPos->MoveNext())
		sortedIndicesOpacity[index++] = Convert::ToInt32(nextPos->get_Key());
	Array::Sort(sortedIndicesOpacity);
}

//Sorts the color indices.
int TransferFuncWin::SortColorIndices(Hashtable *n_ColorSamples) __gc[]
{
	int colorIndices __gc[];
	if (n_ColorSamples->get_Count() != 0)
	colorIndices = new int __gc[n_ColorSamples->get_Count()];
	else 
	return NULL;
	

	IDictionaryEnumerator* nextPos = n_ColorSamples->GetEnumerator();
	int index = 0;

	while (nextPos->MoveNext())
		colorIndices[index++] = Convert::ToInt32(nextPos->get_Key());		 
	Array::Sort(colorIndices);

	return colorIndices;
}

//Sorts the opacity indices.
int TransferFuncWin::SortOpacityIndices(Hashtable *n_OpacitySamples) __gc[]
{
	int opacityIndices __gc[] = new int __gc[n_OpacitySamples->get_Count()];

	IDictionaryEnumerator* nextPos = n_OpacitySamples->GetEnumerator();
	int index = 0;

	while (nextPos->MoveNext())
		opacityIndices[index++] = Convert::ToInt32(nextPos->get_Key());
	Array::Sort(opacityIndices);

	return opacityIndices;
}

//Sets the preview panel.
void TransferFuncWin::setPreViewPanel(Panel* n_Pan_PreView) 
{ 
	this->m_PreviewPanel = n_Pan_PreView; 
}

//Interpolates all values of the transfer function.
Color TransferFuncWin::DoInterpolation(Transferfunction *n_TransFunc, int n_PanelWidth) __gc[]
{
	Color colorFrequency __gc[] = new Color __gc[n_PanelWidth];
	Hashtable *colorSamples = Transferfunction::convertColorSamplesToDrawMode(n_TransFunc->get_ColorSamples(), n_PanelWidth);

	if (colorSamples->get_Count() != 0)
	{
		int sortedIndicesColor __gc[] = SortColorIndices(colorSamples);
			
		for (int i = 0; i <= sortedIndicesColor->Length; i++)
		{
			if (i == 0)
			{
				colorFrequency = InterpolateColorScope(0, 
													sortedIndicesColor[i], 
													n_TransFunc->get_BackColor(), 
													Color::FromArgb(Convert::ToInt32(colorSamples->get_Item(__box(sortedIndicesColor[i])))),
													colorFrequency,
													n_TransFunc->get_InterpolationFactor());
			}
			if (i == sortedIndicesColor->Length)
			{
				colorFrequency = InterpolateColorScope(sortedIndicesColor[i-1], 
													n_PanelWidth, 
													Color::FromArgb(Convert::ToInt32(colorSamples->get_Item(__box(sortedIndicesColor[i-1])))), 
													n_TransFunc->get_BackColor(),
													colorFrequency,
													n_TransFunc->get_InterpolationFactor());
				continue;
			}
			if ( i > 0)
			{
				colorFrequency = InterpolateColorScope(sortedIndicesColor[i-1], 
													sortedIndicesColor[i], 
													Color::FromArgb(Convert::ToInt32(colorSamples->get_Item(__box(sortedIndicesColor[i-1])))), 
													Color::FromArgb(Convert::ToInt32(colorSamples->get_Item(__box(sortedIndicesColor[i])))),
													colorFrequency,
													n_TransFunc->get_InterpolationFactor());
			}

		}
	}
	else
	{
		for(int i = 0; i < colorFrequency->Length; i++)
			colorFrequency[i] = n_TransFunc->get_BackColor();
	}
	return colorFrequency;
}

//Interpolates between two color values.
Color TransferFuncWin::InterpolateColorScope(int x1, int x2, Color c1, Color c2, Color n_ColorFrequency __gc[], float n_InterpolationFactor) __gc[]
{
	//mitte
	if(n_InterpolationFactor == 0.5)
	{
		for (int step = x1; step < x2; step++)
		{
			double x = (double)(step - x1) / (x2 - x1);

			int red   = Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_R())) + (Convert::ToInt32(c2.get_R())) * x));
			int green = Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_G())) + (Convert::ToInt32(c2.get_G())) * x));
			int blue  = Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_B())) + (Convert::ToInt32(c2.get_B())) * x));	
			n_ColorFrequency[step] = Color::FromArgb(red,green,blue);	
		}
	}
	//links
	else if(n_InterpolationFactor < 0.5)
	{	
		double factor = n_InterpolationFactor * 2;
		int length = Math::Abs(x2 - x1);
		for (int step = x1; step < x2; step++)			
		{	
			double x = (double)(step - x1) / ((x1 + length * factor) - x1);
			if(step < x1 + length * factor)
			{
				int red   = Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_R())) + (Convert::ToInt32(c2.get_R())) * (x)));
				int green = Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_G())) + (Convert::ToInt32(c2.get_G())) * (x)));
				int blue  = Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_B())) + (Convert::ToInt32(c2.get_B())) * (x)));
				n_ColorFrequency[step] = Color::FromArgb(red,green,blue);
			}
			else
			{	
				n_ColorFrequency[step] = c2;
			}
		}
	}
	//rechts
	else if(n_InterpolationFactor > 0.5)
	{		
		double factor = (n_InterpolationFactor - 0.5) * 2;
		int length = Math::Abs(x2 - x1);
		for (int step = x1; step < x2; step++)
		{	
			double x = (double)(step - (x1 + length * factor)) / (x2 - (x1 + length * factor));
			if(step < x1 + length * factor)
			{		
				n_ColorFrequency[step] = c1;
			}
			else
			{	
				int red   = Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_R())) + (Convert::ToInt32(c2.get_R())) * (x)));
				int green = Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_G())) + (Convert::ToInt32(c2.get_G())) * (x)));
				int blue  = Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_B())) + (Convert::ToInt32(c2.get_B())) * (x)));
				n_ColorFrequency[step] = Color::FromArgb(red,green,blue);
			}
		}
	}
	
	return n_ColorFrequency;
}

//Interpolates all values.
void TransferFuncWin::do_Interpolation(void)
{
	if (sortedIndicesColor != NULL)
	{
		for (int i = 0; i <= sortedIndicesColor->Length; i++)
		{
			if (i == 0)
			{
				interpolate_ColorScope(0, sortedIndicesColor[i], this->default_RGBValue, Color::FromArgb(Convert::ToInt32(this->colorSamples->get_Item(__box(sortedIndicesColor[i])))));
			}
			if (i == sortedIndicesColor->Length)
			{
				interpolate_ColorScope(sortedIndicesColor[i-1], this->pan_RGB->get_Size().Width, Color::FromArgb(Convert::ToInt32(this->colorSamples->get_Item(__box(sortedIndicesColor[i-1])))), this->default_RGBValue);
				continue;
			}
			if ( i > 0)
			{
				interpolate_ColorScope(sortedIndicesColor[i-1], sortedIndicesColor[i], Color::FromArgb(Convert::ToInt32(this->colorSamples->get_Item(__box(sortedIndicesColor[i-1])))), Color::FromArgb(Convert::ToInt32(this->colorSamples->get_Item(__box(sortedIndicesColor[i])))));
			}

		}
	}
	else
	{
		for(int i = 0; i < TransFunc_Length; i++)
		{
			this->c_TransferFunc[i]   = this->default_RGBValue;	
		}
	}
}

//Interpolated between two color values.
void TransferFuncWin::interpolate_ColorScope(int x1, int x2, Color c1, Color c2)
{
	this->m_InterpolationFactor = (double)this->trb_Interpolation->get_Value() / (double)this->trb_Interpolation->get_Maximum();

	//mitte
	if(this->m_InterpolationFactor == 0.5)
	{
		for (int step = x1; step < x2; step++)
		{
			double x = (double)(step - x1) / (x2 - x1);

			this->c_TransferFunc[step] = Color::FromArgb(Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_R())) + (Convert::ToInt32(c2.get_R())) * x)),
															Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_G())) + (Convert::ToInt32(c2.get_G())) * x)),
															Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_B())) + (Convert::ToInt32(c2.get_B())) * x)));	
		}
	}
	//links
	else if(this->m_InterpolationFactor < 0.5)
	{	
		double factor = this->m_InterpolationFactor * 2;
		int length = Math::Abs(x2 - x1);
		for (int step = x1; step < x2; step++)			
		{	
			double x = (double)(step - x1) / ((x1 + length * factor) - x1);
			if(step < x1 + length * factor)
			{
				this->c_TransferFunc[step] = Color::FromArgb(Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_R())) + (Convert::ToInt32(c2.get_R())) * (x))),
																Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_G())) + (Convert::ToInt32(c2.get_G())) * (x))),
																Convert::ToInt32(Math::Round(((1-x)  * Convert::ToInt32(c1.get_B())) + (Convert::ToInt32(c2.get_B())) * (x))));
			}
			else
			{	
				this->c_TransferFunc[step] = c2;	
			}
		}
	}
	//rechts
	else if(this->m_InterpolationFactor > 0.5)
	{		
		double factor = (this->m_InterpolationFactor - 0.5) * 2;
		int length = Math::Abs(x2 - x1);
		for (int step = x1; step < x2; step++)
		{	
			double x = (double)(step - (x1 + length * factor)) / (x2 - (x1 + length * factor));
			if(step < x1 + length * factor)
			{
				this->c_TransferFunc[step] = c1;
			}
			else
			{	
				this->c_TransferFunc[step] = Color::FromArgb(Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_R())) + (Convert::ToInt32(c2.get_R())) * x)),
																Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_G())) + (Convert::ToInt32(c2.get_G())) * x)),
																Convert::ToInt32(Math::Round(((1 - x)  * Convert::ToInt32(c1.get_B())) + (Convert::ToInt32(c2.get_B())) * x)));
			}
		}
	}	 
}

//Sets the objectID of the transfer function.
void TransferFuncWin::set_selectedObjectID(unsigned short n_SelectedObjectID) 
{ 
	selectedObjectID = n_SelectedObjectID; 
}

//Repaints the density values.
void TransferFuncWin::pan_Density_repaint(void)
{
	Graphics* g = this->pan_Density->CreateGraphics();
	Pen* GrayPen = new Pen(Color::Black, 1);
	int pan_density_Width = this->pan_Density->get_Size().Width;
	int pan_density_Height = this->pan_Density->get_Size().Height;
	short colorIndex = 0;
			
	for (int index  = 0; index < this->pan_Density->get_Size().Width; index++)
	{
		g->DrawLine(GrayPen, index, 0, index++, pan_density_Height);
		g->DrawLine(GrayPen, index, 0, index, pan_density_Height);
		try {
			GrayPen = new Pen(Color::FromArgb(++colorIndex,colorIndex,colorIndex),1);
		} catch (ArgumentException*) { GrayPen = new Pen(Color::White,1); }
	}
}

//Repaints the histogram.
void TransferFuncWin::pan_Histogram_repaint(void)
{
	Graphics* g = this->pan_Histogram->CreateGraphics();
	g->Clear(Color::Beige);

	//Paint the background voxel density statistic

	DataStructures::Histogram *downSampledHistogram = 
		this->m_VolumeData->m_Dataset->getObjectMember(this->selectedObjectID)->get_DensityHistogram()->getDownSampledHistogramValues(SAMPLE_FACTOR);

	double y_Sampling = (double)downSampledHistogram->get_MaxVoxelCount() / (this->pan_Histogram->get_Size().Height - 5);
		
	for (int i = 0; i < this->pan_Histogram->get_Size().Width - 1; i++)
	{	
		g->DrawLine(new Pen(Color::LightGray), i, this->pan_Histogram->get_Size().Height, i, this->pan_Histogram->get_Size().Height - 
			Convert::ToInt32(Math::Round((double)downSampledHistogram->getHistogramValue(i) / y_Sampling)));

	}

	for (int i = 0; i < this->opacitySamples->get_Count() - 1; i++)
	{
		int x1 = this->sortedIndicesOpacity[i];
		int y1 = Convert::ToInt32(this->opacitySamples->get_Item(__box(this->sortedIndicesOpacity[i])));
					

		int x2 = this->sortedIndicesOpacity[i + 1];
		int y2 = Convert::ToInt32(this->opacitySamples->get_Item(__box(this->sortedIndicesOpacity[i + 1])));

		g->DrawLine(new Pen(Color::Gray, 2), x1, y1, x2, y2);

		float k;

		if ((x2 - x1) != 0)
			k = (float)(y2 - y1) / (float)(x2 - x1);
		else 
			k = 0.0f;

		if (colorSamples->get_Count() != 0 && this->m_RenderingMode != TF_MIP_LMIP)
		{
			for (int i = 0; i < this->colorSamples->get_Count(); i++)
			{	
				int currentColorX = sortedIndicesColor[i];
				Color currentSampleColor = Color::FromArgb(Convert::ToInt32(this->colorSamples->get_Item(__box(currentColorX))));

				if (currentColorX > x2) break;
				if (currentColorX >= x1 && currentColorX <= x2)
				{
					SolidBrush* colorBrush = new SolidBrush(currentSampleColor);
					int currentColorY = Convert::ToInt32(Math::Round((float)y1 + ((float)(currentColorX - x1) * k)));
					g->FillEllipse(colorBrush, currentColorX - POINT_SIZE_HALF, currentColorY - POINT_SIZE_HALF, POINT_SIZE_BIG, POINT_SIZE_BIG);	
				}
			}
		}
	}

	IDictionaryEnumerator *nextPos = this->opacitySamples->GetEnumerator();
		
	while (nextPos->MoveNext())
	{
		int x1 = Convert::ToInt32(nextPos->get_Key());
		int y1 = Convert::ToInt32(nextPos->get_Value());

		g->FillRectangle(new SolidBrush(Color::DarkGray), x1 - POINT_SIZE_HALF, y1 - POINT_SIZE_HALF, POINT_SIZE_BIG, POINT_SIZE_BIG);							 
	}
}

//Repaints the RGB histogram.
void TransferFuncWin::pan_RGB_repaint(void)
{
	Graphics* g = this->pan_RGB->CreateGraphics();

	if (this->colorSamples->get_Count() == 0)
		g->Clear(this->default_RGBValue);
	else
	{
		int pan_RGB_Width = this->pan_RGB->get_Size().Width;
		int pan_RGB_Height = this->pan_RGB->get_Size().Height;
	
		for (int index  = 0; index < pan_RGB_Width; index++)
		{ 	
			g->DrawLine(new Pen(this->c_TransferFunc[index]),	
						index, 0, index, pan_RGB_Height);
			}
	}
}

//Expands the title.
void TransferFuncWin::setTitleAddition(String *n_TitleAddition)
{
	this->set_Text(String::Concat(this->MAINTITLE, S" ", n_TitleAddition));
}

//Sets the subitem for the GUI.
void TransferFuncWin::setControlSubItem(TD::SandBar::MenuButtonItem *n_SubItem_EditTransferFuntion)
{
	this->m_SubItem_EditTransferFuntion = n_SubItem_EditTransferFuntion;
}

//Sets the toolbar subitem for the GUI.
void TransferFuncWin::setControlTbSubItem(TD::SandBar::MenuButtonItem *n_TbSubItem_EditTransferFuntion)
{
	this->m_TbSubItem_EditTransferFuntion = n_TbSubItem_EditTransferFuntion;
}