#include "StdAfx.h"
#include ".\Vector2.h"
#using <mscorlib.dll>

using namespace IDVR::Tools;
	
/*
This is the standard constructor.
This standard constructor initialzed both elements with zero.
*/
Vector2::Vector2(void)
{
	this->m_X = this->m_Y = 0;
}

/*
Constructor initialization by two parameters.
This constructor initialized both element of the vector with the specified parameters.
*/
Vector2::Vector2(double n_X, double n_Y)
{
	this->m_X = n_X;
	this->m_Y = n_Y;
}

/*
Constructor initialization by an array parameters.
This constructor initialized both element of the vector with the specified array parameter.
*/
Vector2::Vector2(double n_Value __gc[])
{	this->m_X = n_Value[0]; 
	this->m_Y = n_Value[1]; 
}

/**********************************************************************************************************************/
/**********************************************************************************************************************/
	
//Returns the x element of the specific vector.
double Vector2::get_X(void)
{
	return this->m_X;
}

//Returns the y element of the specific vector.
double Vector2::get_Y(void)
{
	return this->m_Y;
}

//Sets the x element of the existing vector.
void Vector2::set_X(double n_X)
{
	this->m_X = n_X;
}

//Sets the y element of the existing vector.
void Vector2::set_Y(double n_Y)
{
	this->m_Y = n_Y;
}

//Returns the magnitude of the specific vector.
double Vector2::magnitude(void)
{
	return (double)Math::Sqrt((this->m_X * this->m_X) + (this->m_Y * this->m_Y));
}

/**********************************************************************************************************************/
/**********************************************************************************************************************/

//This static function created a normalized vector of the specified vector parameter.
Vector2* Vector2::CreateNormalizedVector(Vector2* v)
{
	 double d_mag = v->magnitude();
	
	 if (d_mag != 0)
	 {
		 v->X /= d_mag;
		 v->Y /= d_mag;
	 }
	 return v;
}

//This static function returns the sum vector of the two specified vector parameters.
Vector2* Vector2::Addition(Vector2* v1, Vector2* v2)
{
	return new Vector2(v1->X + v2->X, v1->Y + v2->Y);
}

//This static function returns the subtraction vector of the two specified vector parameters.
Vector2* Vector2::Subtraction(Vector2* v1, Vector2* v2)
{
	return new Vector2(v1->X - v2->X, v1->Y - v2->Y); 
}